package tsuteto.tofu.world.gen.layer;

import net.minecraft.world.gen.layer.GenLayer;
import net.minecraft.world.gen.layer.IntCache;
import tsuteto.tofu.world.biome.TcBiomes;

public class GenLayerHills extends GenLayerTofu
{
    private GenLayer genLayer;

    public GenLayerHills(long par1, GenLayerTofu par3GenLayer, GenLayerTofu par4GenLayer)
    {
        super(par1);
        this.parent = par3GenLayer;
        this.genLayer = par4GenLayer;
    }

    /**
     * Returns a list of integer values generated by this layer. These may be interpreted as temperatures, rainfall
     * amounts, or biomeList[] indices based on the particular GenLayer subclass.
     */
    @Override
    public int[] getInts(int par1, int par2, int par3, int par4)
    {
        int[] aint = this.parent.getInts(par1 - 1, par2 - 1, par3 + 2, par4 + 2);
        int[] aint1 = this.genLayer.getInts(par1 - 1, par2 - 1, par3 + 2, par4 + 2);
        int[] aint2 = IntCache.getIntCache(par3 * par4);

        for (int i1 = 0; i1 < par4; ++i1)
        {
            for (int j1 = 0; j1 < par3; ++j1)
            {
                this.initChunkSeed((j1 + par1), (i1 + par2));
                int k1 = aint[j1 + 1 + (i1 + 1) * (par3 + 2)];
                int l1 = aint1[j1 + 1 + (i1 + 1) * (par3 + 2)];

                if (l1 >= 2 && (l1 - 2) % 29 == 1)
                {
                    aint2[j1 + i1 * par3] = k1;
                }
                else if (this.nextInt(3) != 0)
                {
                    aint2[j1 + i1 * par3] = k1;
                }
                else
                {
                    int i2 = k1;
                    int j2;

                    if (k1 == TcBiomes.tofuPlains.biomeID)
                    {
                        i2 = TcBiomes.tofuPlainHills.biomeID;
                    }
                    else if (k1 == TcBiomes.tofuForest.biomeID)
                    {
                        i2 = TcBiomes.tofuForestHills.biomeID;
                    }

                    if (i2 == k1)
                    {
                        aint2[j1 + i1 * par3] = k1;
                    }
                    else
                    {
                        j2 = aint[j1 + 1 + (i1 + 1 - 1) * (par3 + 2)];
                        int k2 = aint[j1 + 1 + 1 + (i1 + 1) * (par3 + 2)];
                        int l2 = aint[j1 + 1 - 1 + (i1 + 1) * (par3 + 2)];
                        int i3 = aint[j1 + 1 + (i1 + 1 + 1) * (par3 + 2)];
                        int j3 = 0;

                        if (compareBiomesById(j2, k1))
                        {
                            ++j3;
                        }

                        if (compareBiomesById(k2, k1))
                        {
                            ++j3;
                        }

                        if (compareBiomesById(l2, k1))
                        {
                            ++j3;
                        }

                        if (compareBiomesById(i3, k1))
                        {
                            ++j3;
                        }

                        if (j3 >= 3)
                        {
                            aint2[j1 + i1 * par3] = i2;
                        }
                        else
                        {
                            aint2[j1 + i1 * par3] = k1;
                        }
                    }
                }
            }
        }

        return aint2;
    }
}
